//********************************************************************
//*** ResourcePool/ResourcePoolType.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: ResourcePoolType.hh,v 1.5 2008/01/27 16:42:28 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_RESOURCEPOOLTYPE_HH
#define RESOURCEPOOL_RESOURCEPOOLTYPE_HH

#include "Thread/Lock.hh"

namespace fatalmind {

template<class F>
class NopCommand {
	public:
		NopCommand(const F&) {
		};
};

template<class F  /* Factory */
	, class RR      /* Resource */
	, class PR      /* Plain Resource */
	, class Command = NopCommand<F> /* command */
	, class TM = DefaultThreadedModel /* Threading model */
> class PoolType {
	public:
		typedef F factory_t;
		typedef RR resource_t;
		typedef PR plainresource_t;
		typedef Command command_t;
		typedef TM ThreadingModell;
};

} // namespace fatalmind

#endif
