#include <memory>
#include "ResourcePool/mysql/ResourcePool.hh"
#include "t/main.hh"

#include "testconfig.cc"

std::auto_ptr<RP> rp;

std::string getStringTable(RP& p) {
    return "create table fatalmind_str (id numeric not null primary key, val  varchar(255))";
}

std::string getLobTable(RP& p) {
    return "create table fatalmind_lob (id numeric not null primary key, val  LONGBLOB)";
}

#include "../SQL/Types.t.cc"

void INIT_mysql_Types()
{
	rp.reset(new RP(getFactory()));
	test_Types_init(*rp);
}

void TEST_mysql_Types_int()
{
	test_Types_int(*rp);
}

void TEST_mysql_Types_float()
{
	test_Types_float(*rp);
}
void TEST_mysql_Types_double()
{
	test_Types_double(*rp);
}
void TEST_mysql_Types_crosstype_string()
{
	test_Types_crosstype_string(*rp);
}
void TEST_mysql_Types_string_crosstype()
{
	test_Types_string_crosstype(*rp);
}
void TEST_mysql_Types_string()
{
	test_Types_string(*rp);
}
void TEST_mysql_Types_lob()
{
	test_Types_lob(*rp);
}
void TEST_PERF_mysql_Types_lob_4k()
{
	test_perf_Types_lob_4k(*rp);
}
void TEST_PERF_mysql_Types_lob_64k()
{
	test_perf_Types_lob_64k(*rp);
}
void TEST_PERF_mysql_Types_lob_1024k()
{
	test_perf_Types_lob_1024k(*rp);
}
