//********************************************************************
//*** ResourcePool/oracle/OracleException.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: OracleException.hh,v 1.13 2008/01/27 16:42:29 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_ORACLE_ORACLEEXCEPTION_HH
#define RESOURCEPOOL_ORACLE_ORACLEEXCEPTION_HH

#ifndef INCLUDED_EXCEPTIONS_HH
#include "Exceptions/Exception.hh"
#endif

#ifndef RESOURCEPOOL_SQL_SQLException_HH
#include "ResourcePool/SQL/SQLException.hh"
#endif

#ifndef RESOURCEPOOL_NOFAILOVEREXCEPTION_HH
#include "ResourcePool/NoFailoverException.hh"
#endif

namespace fatalmind {

class OracleExceptionFactory;

class OracleException: virtual public SQL::SQLException {
	public:
		OracleException(const OracleException&); // c-ctor
		OracleException(const std::string& message, const int errorcode, const std::string& sqlstm);
		int getErrorCode() const;
	protected:
		static const char* mapORAtoXOPEN(const int errorcode);
		const int _errorcode;
	friend
		class OracleExceptionFactory;
};

class NFOOracleException
: virtual public OracleException
, virtual public NoFailoverException 
{
	public:
		NFOOracleException(const std::string& message, const int errorcode, const std::string& sqlstm);
};

} // namespace fatalmind

#endif
