//********************************************************************
//*** operators/epsilon_eq.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: epsilon_eq.hh,v 1.4 2008/01/27 16:42:29 mws Exp $
//********************************************************************

#ifndef OPERATORS_EPSILON_EQ_HH
#define OPERATORS_EPSILON_EQ_HH

#include <cmath>
#include <limits>
//#include <iostream>

namespace fatalmind {
namespace operators {
	template<typename T>
	bool epsilon_eq(const T lho, const T rho) {
//		std::cerr << "default epsilon_eq" << std::endl;
		return (lho == rho);
	}

	// specializations
	bool epsilon_eq(const float lho, const float rho);
	bool epsilon_eq(const double lho, const double rho);
}
}

#endif
